package io.swagger.api;


import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

@javax.annotation.Generated(value = "class io.swagger.codegen.languages.SpringCodegen", date = "2016-11-03T11:51:04.465+04:00")

@Api(value = "auth", description = "the auth API")
public interface AuthApi {

    @ApiOperation(value = "Получить ключ доступа", notes = "Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр 'token'). Для вычисления значения параметра 'response' необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&nbsp;+&nbsp;salt&nbsp;+&nbsp;'\\n'))", response = String.class, tags={ "auth / Авторизация, начало работы с API", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Ключ доступа", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/auth/login",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.POST)
    ResponseEntity<String> authLoginPost(@ApiParam(value = "Имя пользователя", required = true) @RequestParam(value = "login", required = true) String login,@ApiParam(value = "Соль (см. /auth/start)", required = true) @RequestParam(value = "salt", required = true) String salt,@ApiParam(value = "Вычисленный хэш", required = true) @RequestParam(value = "response", required = true) String response);


    @ApiOperation(value = "Получить соль", notes = "Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.", response = String.class, tags={ "auth / Авторизация, начало работы с API", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Соль для авторизации", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/auth/start",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> authStartGet(@ApiParam(value = "Имя пользователя", required = true) @RequestParam(value = "login", required = true) String login);

}
