package io.swagger.api;

import io.swagger.model.InlineResponse200;
import io.swagger.model.InlineResponse2001;
import io.swagger.model._;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

@javax.annotation.Generated(value = "class io.swagger.codegen.languages.SpringCodegen", date = "2016-11-03T11:51:04.465+04:00")

@Api(value = "billing", description = "the billing API")
public interface BillingApi {

    @ApiOperation(value = "Информация по дебету аккаунта", notes = "Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения", response = InlineResponse200.class, responseContainer = "List", tags={ "Аккаунт - биллинг, свойства и статус", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Информация по дебету аккаунта", response = InlineResponse200.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse200.class) })
    @RequestMapping(value = "/billing/debt",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<List<InlineResponse200>> billingDebtGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_);


    @ApiOperation(value = "Информация об аккаунте", notes = "Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.", response = InlineResponse2001.class, responseContainer = "List", tags={ "Аккаунт - биллинг, свойства и статус", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Информация об аккаунте", response = InlineResponse2001.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2001.class) })
    @RequestMapping(value = "/billing/info",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<List<InlineResponse2001>> billingInfoGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_);


    @ApiOperation(value = "Получить ограничения аккаунта", notes = "", response = _.class, tags={ "Аккаунт - биллинг, свойства и статус", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Ограничения аккаунта", response = _.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = _.class) })
    @RequestMapping(value = "/billing/limits",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<_> billingLimitsGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_);

}
