package io.swagger.api;

import io.swagger.model.InlineResponse2003;
import io.swagger.model.InlineResponse2004;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

@javax.annotation.Generated(value = "class io.swagger.codegen.languages.SpringCodegen", date = "2016-11-03T11:51:04.465+04:00")

@Api(value = "dns", description = "the dns API")
public interface DnsApi {

    @ApiOperation(value = "Создание записи домена", notes = "", response = String.class, tags={ "DNS - доменные имена, привязки", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/dns/add",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> dnsAddGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "зона, которую необходимо создать", required = true) @RequestParam(value = "addDnsZone", required = true) String addDnsZone,@ApiParam(value = "") @RequestParam(value = "addDnsRecord", required = false) String addDnsRecord,@ApiParam(value = "ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку") @RequestParam(value = "iisSiteForDns", required = false) String iisSiteForDns,@ApiParam(value = "") @RequestParam(value = "bindOnly", required = false) Boolean bindOnly);


    @ApiOperation(value = "Привязка одного домена к другому", notes = "", response = String.class, tags={ "DNS - доменные имена, привязки", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/dns/bind",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> dnsBindGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID домена из списка /dns/list", required = true) @RequestParam(value = "key_", required = true) Integer key_,@ApiParam(value = "домен, к которому необходимо сделать привязку") @RequestParam(value = "bindTo", required = false) String bindTo);


    @ApiOperation(value = "Получить список доменных имён", notes = "", response = InlineResponse2003.class, responseContainer = "List", tags={ "DNS - доменные имена, привязки", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Список доменных имён", response = InlineResponse2003.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2003.class) })
    @RequestMapping(value = "/dns/list",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<List<InlineResponse2003>> dnsListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_);


    @ApiOperation(value = "Информация по продлению доменов", notes = "", response = InlineResponse2004.class, responseContainer = "List", tags={ "DNS - доменные имена, привязки","Аккаунт - биллинг, свойства и статус", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Информация по продлению доменов", response = InlineResponse2004.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2004.class) })
    @RequestMapping(value = "/dns/prolong/list",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<List<InlineResponse2004>> dnsProlongListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_);


    @ApiOperation(value = "Редактирование \"сырой\" зоны", notes = "", response = String.class, tags={ "DNS - доменные имена, привязки", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/dns/raw",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> dnsRawGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID домена из /dns/list", required = true) @RequestParam(value = "key_", required = true) Integer key_,@ApiParam(value = "Значение '1' сообщает, что запись необходимо удалить", required = true) @RequestParam(value = "sDel", required = true) Integer sDel,@ApiParam(value = "Значение '1' сообщает, что запись необходимо создать", required = true) @RequestParam(value = "sAdd", required = true) Integer sAdd,@ApiParam(value = "Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV", required = true) @RequestParam(value = "dnsType", required = true) String dnsType,@ApiParam(value = "Имя записи, либо '@' для корневой", required = true) @RequestParam(value = "dnsName", required = true) String dnsName,@ApiParam(value = "Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)", required = true) @RequestParam(value = "dnsValue", required = true) String dnsValue);


    @ApiOperation(value = "Редактировать DNS-зону", notes = "", response = String.class, tags={ "DNS - доменные имена, привязки", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/dns/raw/managedmx",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> dnsRawManagedmxGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID домена из /dns/list", required = true) @RequestParam(value = "key_", required = true) Integer key_,@ApiParam(value = "Значение '1', если необходимо включить поддержку на MX-серверах хостинга и '0', если выключить", required = true) @RequestParam(value = "managedMx", required = true) Integer managedMx,@ApiParam(value = "Значение '1' подтверждает операцию", required = true) @RequestParam(value = "updManagedMx", required = true) Integer updManagedMx);

}
