package io.swagger.api;

import io.swagger.model.InlineResponse2005;
import io.swagger.model.InlineResponse2006;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

@javax.annotation.Generated(value = "class io.swagger.codegen.languages.SpringCodegen", date = "2016-11-03T11:51:04.465+04:00")

@Api(value = "email", description = "the email API")
public interface EmailApi {

    @ApiOperation(value = "Создание почтового ящика", notes = "", response = String.class, tags={ "Электронная почта - почтовые ящики", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/email/add",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> emailAddGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "Адрес почтового ящика, который необходимо создать", required = true) @RequestParam(value = "addEmail", required = true) String addEmail);


    @ApiOperation(value = "Удаление псевдонимов почтовых ящиков", notes = "", response = String.class, tags={ "Электронная почта - почтовые ящики", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/email/alias/delete",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> emailAliasDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "Адрес почтового ящика, подлежащего удалению", required = true) @RequestParam(value = "key_", required = true) String key_);


    @ApiOperation(value = "Получить список псевдонимов почтовых ящиков", notes = "", response = InlineResponse2005.class, responseContainer = "List", tags={ "Электронная почта - почтовые ящики", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Список псевдонимов почтовых ящиков", response = InlineResponse2005.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2005.class) })
    @RequestMapping(value = "/email/alias/list",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<List<InlineResponse2005>> emailAliasListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_);


    @ApiOperation(value = "Удаление почтового ящика", notes = "", response = String.class, tags={ "Электронная почта - почтовые ящики", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/email/delete",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> emailDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "Адрес почтового ящика, подлежащего удалению", required = true) @RequestParam(value = "key_", required = true) String key_);


    @ApiOperation(value = "Получить список почтовых ящиков", notes = "", response = InlineResponse2006.class, responseContainer = "List", tags={ "Электронная почта - почтовые ящики", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Список почтовых ящиков", response = InlineResponse2006.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse2006.class) })
    @RequestMapping(value = "/email/list",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<List<InlineResponse2006>> emailListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_);

}
