package io.swagger.api;

import io.swagger.model.InlineResponse20011;
import io.swagger.model.InlineResponse20012;
import io.swagger.model.InlineResponse20013;

import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

@javax.annotation.Generated(value = "class io.swagger.codegen.languages.SpringCodegen", date = "2016-11-03T11:51:04.465+04:00")

@Api(value = "vds", description = "the vds API")
public interface VdsApi {

    @ApiOperation(value = "Изменение параметров VDS", notes = "Изменение параметров уже существующего VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "ID VDS", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/vds/create",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> vdsCreateGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "Тип создаваемого VDS. 'vz1', 'vz2', 'vz3', 'vz4', 'vz5' или 'vds.dynamic'. По умолчанию 'vds.dynamic'") @RequestParam(value = "type", required = false) String type,@ApiParam(value = "Количество доступной памяти в мегабайтах. По умолчанию 2048") @RequestParam(value = "crHvmem", required = false) Integer crHvmem,@ApiParam(value = "Количество доступных гигабайт диска. По умолчанию 30") @RequestParam(value = "crHvdsk", required = false) Integer crHvdsk,@ApiParam(value = "Количество ядер CPU. По умолчанию 2") @RequestParam(value = "crHvcpu", required = false) Integer crHvcpu,@ApiParam(value = "Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list") @RequestParam(value = "template", required = false) String template,@ApiParam(value = "") @RequestParam(value = "forceMemo", required = false) String forceMemo,@ApiParam(value = "") @RequestParam(value = "hv1gbPanelVersion", required = false) String hv1gbPanelVersion,@ApiParam(value = "Необходимо ли установить панель 1Gb на VDS") @RequestParam(value = "panelInstall", required = false) Boolean panelInstall,@ApiParam(value = "Создать всю систему на SSD") @RequestParam(value = "crSsd1", required = false) Boolean crSsd1,@ApiParam(value = "Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)") @RequestParam(value = "crHvAllSystem", required = false) Boolean crHvAllSystem);


    @ApiOperation(value = "Удаление VDS", notes = "Предоставляет функционал для удаления VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/vds/delete",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> vdsDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_,@ApiParam(value = "Если true, VDS будет удален срочно") @RequestParam(value = "forceCritical", required = false) Boolean forceCritical);


    @ApiOperation(value = "Добавление IP на VDS", notes = "Этот вызов позволяет добавить ещё один IP адрес на указанный VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "IP-адрес успешно добавлен", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/vds/ip/add",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> vdsIpAddGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_);


    @ApiOperation(value = "Удаление IP с VDS", notes = "Этот вызов позволяет отвязать IP адрес от VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "IP-адрес успешно удалён", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/vds/ip/delete",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> vdsIpDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_,@ApiParam(value = "IP адрес, который необходимо удалить", required = true) @RequestParam(value = "delIp", required = true) String delIp);


    @ApiOperation(value = "Список IP-адресов виртуальных серверов", notes = "Список IP-адресов виртуальных серверов", response = InlineResponse20011.class, responseContainer = "List", tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Список IP-адресов виртуальных серверов", response = InlineResponse20011.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse20011.class) })
    @RequestMapping(value = "/vds/ip/list",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<List<InlineResponse20011>> vdsIpListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list") @RequestParam(value = "key_", required = false) Integer key_);


    @ApiOperation(value = "Список виртуальных серверов", notes = "Позволяет получить список виртуальных серверов", response = InlineResponse20012.class, responseContainer = "List", tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Список виртуальных серверов", response = InlineResponse20012.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse20012.class) })
    @RequestMapping(value = "/vds/list",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<List<InlineResponse20012>> vdsListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS") @RequestParam(value = "key_", required = false) Integer key_);


    @ApiOperation(value = "Перезагрузка VDS", notes = "Предоставляет функционал для перезагрузки VDS", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Возврат строки 'OK' означает успех операции", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/vds/reboot",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> vdsRebootGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_);


    @ApiOperation(value = "Список шаблонов виртуальных серверов", notes = "Позволяет получить список шаблонов виртуальных серверов", response = InlineResponse20013.class, responseContainer = "List", tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Список шаблонов виртуальных серверов", response = InlineResponse20013.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = InlineResponse20013.class) })
    @RequestMapping(value = "/vds/templates-list",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<List<InlineResponse20013>> vdsTemplatesListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_);


    @ApiOperation(value = "Создание VDS", notes = "Создание новых VDS с произвольными характеристиками", response = String.class, tags={ "VDS - виртуальные сервера Hyper-V / OpenVZ", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "Параметры VDS успешно обновлены", response = String.class),
        @ApiResponse(code = 200, message = "Общая ошибка от сервера", response = String.class) })
    @RequestMapping(value = "/vds/update",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.GET)
    ResponseEntity<String> vdsUpdateGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,@ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_,@ApiParam(value = "Количество доступной памяти в мегабайтах. По умолчанию 2048") @RequestParam(value = "crHvmem", required = false) Integer crHvmem,@ApiParam(value = "Количество доступных гигабайт диска. По умолчанию 30") @RequestParam(value = "crHvdsk", required = false) Integer crHvdsk,@ApiParam(value = "Количество ядер CPU. По умолчанию 2") @RequestParam(value = "crHvcpu", required = false) Integer crHvcpu);

}
