package io.swagger.api;

import io.swagger.model.InlineResponse20011;
import io.swagger.model.InlineResponse20012;
import io.swagger.model.InlineResponse20013;

import io.swagger.annotations.*;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;


@javax.annotation.Generated(value = "class io.swagger.codegen.languages.SpringCodegen", date = "2016-11-03T11:51:04.465+04:00")

@Controller
public class VdsApiController implements VdsApi {

    public ResponseEntity<String> vdsCreateGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,
        @ApiParam(value = "Тип создаваемого VDS. 'vz1', 'vz2', 'vz3', 'vz4', 'vz5' или 'vds.dynamic'. По умолчанию 'vds.dynamic'") @RequestParam(value = "type", required = false) String type,
        @ApiParam(value = "Количество доступной памяти в мегабайтах. По умолчанию 2048") @RequestParam(value = "crHvmem", required = false) Integer crHvmem,
        @ApiParam(value = "Количество доступных гигабайт диска. По умолчанию 30") @RequestParam(value = "crHvdsk", required = false) Integer crHvdsk,
        @ApiParam(value = "Количество ядер CPU. По умолчанию 2") @RequestParam(value = "crHvcpu", required = false) Integer crHvcpu,
        @ApiParam(value = "Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list") @RequestParam(value = "template", required = false) String template,
        @ApiParam(value = "") @RequestParam(value = "forceMemo", required = false) String forceMemo,
        @ApiParam(value = "") @RequestParam(value = "hv1gbPanelVersion", required = false) String hv1gbPanelVersion,
        @ApiParam(value = "Необходимо ли установить панель 1Gb на VDS") @RequestParam(value = "panelInstall", required = false) Boolean panelInstall,
        @ApiParam(value = "Создать всю систему на SSD") @RequestParam(value = "crSsd1", required = false) Boolean crSsd1,
        @ApiParam(value = "Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)") @RequestParam(value = "crHvAllSystem", required = false) Boolean crHvAllSystem) {
        // do some magic!
        return new ResponseEntity<String>(HttpStatus.OK);
    }

    public ResponseEntity<String> vdsDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,
        @ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_,
        @ApiParam(value = "Если true, VDS будет удален срочно") @RequestParam(value = "forceCritical", required = false) Boolean forceCritical) {
        // do some magic!
        return new ResponseEntity<String>(HttpStatus.OK);
    }

    public ResponseEntity<String> vdsIpAddGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,
        @ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_) {
        // do some magic!
        return new ResponseEntity<String>(HttpStatus.OK);
    }

    public ResponseEntity<String> vdsIpDeleteGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,
        @ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_,
        @ApiParam(value = "IP адрес, который необходимо удалить", required = true) @RequestParam(value = "delIp", required = true) String delIp) {
        // do some magic!
        return new ResponseEntity<String>(HttpStatus.OK);
    }

    public ResponseEntity<List<InlineResponse20011>> vdsIpListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,
        @ApiParam(value = "ID виртуального сервера, полученный из /vds/list") @RequestParam(value = "key_", required = false) Integer key_) {
        // do some magic!
        return new ResponseEntity<List<InlineResponse20011>>(HttpStatus.OK);
    }

    public ResponseEntity<List<InlineResponse20012>> vdsListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,
        @ApiParam(value = "ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS") @RequestParam(value = "key_", required = false) Integer key_) {
        // do some magic!
        return new ResponseEntity<List<InlineResponse20012>>(HttpStatus.OK);
    }

    public ResponseEntity<String> vdsRebootGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,
        @ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_) {
        // do some magic!
        return new ResponseEntity<String>(HttpStatus.OK);
    }

    public ResponseEntity<List<InlineResponse20013>> vdsTemplatesListGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_) {
        // do some magic!
        return new ResponseEntity<List<InlineResponse20013>>(HttpStatus.OK);
    }

    public ResponseEntity<String> vdsUpdateGet(@ApiParam(value = "Ключ доступа, полученный при авторизации", required = true) @RequestParam(value = "token_", required = true) String token_,
        @ApiParam(value = "ID виртуального сервера, полученный из /vds/list", required = true) @RequestParam(value = "key_", required = true) Integer key_,
        @ApiParam(value = "Количество доступной памяти в мегабайтах. По умолчанию 2048") @RequestParam(value = "crHvmem", required = false) Integer crHvmem,
        @ApiParam(value = "Количество доступных гигабайт диска. По умолчанию 30") @RequestParam(value = "crHvdsk", required = false) Integer crHvdsk,
        @ApiParam(value = "Количество ядер CPU. По умолчанию 2") @RequestParam(value = "crHvcpu", required = false) Integer crHvcpu) {
        // do some magic!
        return new ResponseEntity<String>(HttpStatus.OK);
    }

}
